import { useParams } from 'solid-start';
import { createServerAction$ } from 'solid-start/server';
import PouchDb from 'pouchdb';
import Invitation from '~/components/invitation';
import { createEffect, Show } from 'solid-js';

export default () => {
  const params = useParams();
  const [invitation, getInvitation] = createServerAction$(
    async (id: string) => {
      const db = new PouchDb('.db');
      const result = await db.get(id);
      console.log({ caller: 'Invitations / serverAction', result });
      return result;
    }
  );

  getInvitation(decodeURIComponent(params.id));

  createEffect(() => {
    console.log({
      caller: 'Invitations/[id]',
      params,
      invitation: invitation.result,
    });
  });

  return (
    <main>
      <h1>Invitation: </h1>
      <Show when={!invitation.pending} fallback={<>Loading...</>}>
        <Invitation values={invitation.result} />
      </Show>
    </main>
  );
};
